#include < amxmodx >
#include < amxmisc >
#include < hamsandwich >
#include < fakemeta >
#include < cromchat >
#include < eas_ranks >
#include < eas_core >
#include < cstrike >

#define PLUGIN_AUTHOR "DoNii"
#define PLUGIN_NAME "Elite Admin System"

new const szVersion[ ] = "6.7.2";

#define SERVER_ID 0

#if defined client_disconnected
#define client_disconnect client_disconnected
#endif

#define SetUserModeled(%1)		g_bModeled |= 1<<(%1 & 31)
#define SetUserNotModeled(%1)		g_bModeled &= ~( 1<<(%1 & 31) )
#define IsUserModeled(%1)		( g_bModeled &  1<<(%1 & 31) )

#define m_iTeam 114
#define g_ulModelIndexPlayer 491
#define fm_cs_get_user_team_index(%1)	get_pdata_int(%1, m_iTeam)

enum
{
	CHAT = 0,
	CONSOLE,
	LOG
}

enum
{
	TEAM_UNASSIGNED = 0,
	TEAM_T,
	TEAM_CT,
	TEAM_SPEC
}

enum _:PlayerData
{
	Player_Name[ MAX_NAME_LENGTH ],
	Player_SteamID[ MAX_AUTHID_LENGTH ],
	Player_Password[ MAX_PASSWORD_LENGTH ],
	Player_AccessFlags[ MAX_FLAGS_LENGTH ],
	Player_Prefix[ 32 ],
	Player_Model_T[ 64 ],
	Player_Model_CT[ 64 ],
	Player_Expire_Date[ MAX_DATE_LENGTH ],
	Player_FlagsExpire[ MAX_FLAGS_LENGTH ],
	Player_Immunity,
	bool:Player_Suspended,
	bool:Player_Expired,
	bool:Player_KeepPrivileges
}

enum _:eConfig
{
	DEAD_PREFIX[ 32 ],
	SPECTATOR_PREFIX[ 32 ],
	COMMAND_ADDADMIN[ 32 ],
	USERS_FILE[ 32 ],
	BANS_FILE[ 32 ],
	LOGS_FILE[ 32 ],
	SYSTEM_PREFIX[ 32 ],
	ADMIN_ADD_FLAG,
	CONNECT_LOG,
	NAME_CHANGE_LOG,
	CHAT_LOG,
	RANKS_IN_CHAT,
	CHAT_FLAG,
	SHOW_ADMIN_EXPIRE_DATE,
	ADMIN_EXPIRE_CMD[ 32 ],
	Float:FREQUENCY_UPDATE_ALL_FILES,
	bool:ENABLE_MODELS,
	bool:TEAM_SAY,
	DEFAULT_MODEL_T[ 64 ],
	DEFAULT_MODEL_CT[ 64 ]
}

enum _:Commands
{
	Cmd_Name[ 32 ],
	Cmd_Callback[ 32 ],
	Cmd_Flags,
	Cmd_Immunity,
	Cmd_Plugin,
	Cmd_FuncId
}

new Array:g_aCommands, Array:g_aTrieKeys;
new Trie:g_tPlayerModels[ 2 ], Trie:g_tDatabase;

new g_iFwAdminAdded, g_iDummyResult, g_iSayTxtMsg, g_iInfoChangedFwd;

new g_iConfig[ eConfig ];

new g_szConfigsDir[ MAX_CONFIGS_LENGTH ], g_szCurrentModel[ MAX_PLAYERS + 1 ][ 64 ], g_szName[ MAX_PLAYERS + 1 ][ MAX_NAME_LENGTH ], g_szAuthId[ MAX_PLAYERS + 1 ][ MAX_AUTHID_LENGTH ], g_szIp[ MAX_PLAYERS + 1 ][ MAX_IP_LENGTH ];

new bool:g_bPersonalModel[ MAX_PLAYERS + 1 ], g_bAlive[ MAX_PLAYERS + 1 ], g_bConnected[ MAX_PLAYERS + 1 ];

new g_bModeled;

public plugin_precache( )
{
	get_configsdir( g_szConfigsDir, charsmax( g_szConfigsDir ) );
	
	register_dictionary( "elite_admin_system.txt" );
	
	g_aCommands = ArrayCreate( Commands );
	g_aTrieKeys = ArrayCreate( MAX_AUTHID_LENGTH );
	
	g_tPlayerModels[ 0 ] = TrieCreate( );
	g_tPlayerModels[ 1 ] = TrieCreate( );
	g_tDatabase = TrieCreate( );
	
	ReadConfig( );
	ReloadFile( );
	
	register_forward( FM_ClientKill, "FwdClientKill" );
	
	if( g_iConfig[ ENABLE_MODELS ] )
	{
		new szNewDefaultModels[ 128 ];
		
		if( g_iConfig[ DEFAULT_MODEL_T ][ 0 ] )
		{
			if( ModelExists( g_iConfig[ DEFAULT_MODEL_T ] ) )
			{
				formatex( szNewDefaultModels, charsmax( szNewDefaultModels ), "models/player/%s/%s.mdl", g_iConfig[ DEFAULT_MODEL_T ], g_iConfig[ DEFAULT_MODEL_T ] );
				precache_model( szNewDefaultModels );
			}
			
			else
			{
				send_message( 0, LOG, false, "%L", LANG_PLAYER, "MISSING_DEFAULT_MODEL", g_iConfig[ DEFAULT_MODEL_T ] );
			}
		}
		
		if( g_iConfig[ DEFAULT_MODEL_CT ][ 0 ] )
		{
			if( ModelExists( g_iConfig[ DEFAULT_MODEL_CT ] ) )
			{
				formatex( szNewDefaultModels, charsmax( szNewDefaultModels ), "models/player/%s/%s.mdl", g_iConfig[ DEFAULT_MODEL_CT ], g_iConfig[ DEFAULT_MODEL_CT ] );
				precache_model( szNewDefaultModels );
			}
			
			else
			{
				send_message( 0, LOG, false, "%L", LANG_PLAYER, "MISSING_DEFAULT_MODEL", g_iConfig[ DEFAULT_MODEL_CT ] );
			}
		}
		
		new szKey[ MAX_AUTHID_LENGTH ], eData[ PlayerData ], szModel[ 128 ];
		for( new i; i < ArraySize( g_aTrieKeys ); i++ )
		{
			ArrayGetString( g_aTrieKeys, i, szKey, charsmax( szKey ) );
			
			if( TrieGetArray( g_tDatabase, szKey, eData, sizeof eData ) )
			{
				if( eData[ Player_SteamID ][ 0 ] )
				{
					if( eData[ Player_Suspended ] || ( eData[ Player_Expired ] && !eData[ Player_KeepPrivileges ] ) )
					{
						continue;
					}
					
					if( eData[ Player_Model_T ][ 0 ] )
					{
						formatex( szModel, charsmax( szModel ), "models/player/%s/%s.mdl", eData[ Player_Model_T ], eData[ Player_Model_T ] );
						precache_model( szModel );
						
						TrieSetString( g_tPlayerModels[ 0 ], eData[ Player_SteamID ], eData[ Player_Model_T ] );
					}
					
					if( eData[ Player_Model_CT ][ 0 ] )
					{
						formatex( szModel, charsmax( szModel ), "models/player/%s/%s.mdl", eData[ Player_Model_CT ], eData[ Player_Model_CT ] );
						precache_model( szModel );
						
						TrieSetString( g_tPlayerModels[ 1 ], eData[ Player_SteamID ], eData[ Player_Model_CT ] );
					}
				}
			}
		}
	}
	
	switch( g_iConfig[ SHOW_ADMIN_EXPIRE_DATE ] )
	{
	case 1:
		{
			register_clcmd( "joinclass", "OnClassSelect" ); // joinclass
		}
		
	case 2:
		{
			new szExpireDateCmd[ 32 ];
			formatex( szExpireDateCmd, charsmax( szExpireDateCmd ), "say %s", g_iConfig[ ADMIN_EXPIRE_CMD ] );
			
			register_clcmd( szExpireDateCmd, "OnAdminExpireDateShow" ); // command
		}
		
	case 3:
		{
			register_clcmd( "joinclass", "OnClassSelect" );
			
			new szExpireDateCmd[ 32 ];
			formatex( szExpireDateCmd, charsmax( szExpireDateCmd ), "say %s", g_iConfig[ ADMIN_EXPIRE_CMD ] );
			
			register_clcmd( szExpireDateCmd, "OnAdminExpireDateShow" ); // both
		}
	}
}

public plugin_end( )
{
	TrieDestroy( g_tDatabase );
	ArrayDestroy( g_aCommands );
}

public plugin_init( )
{
	register_plugin( PLUGIN_NAME, szVersion, PLUGIN_AUTHOR );
	
	new szPrefix[ 32 ];
	formatex( szPrefix, charsmax( szPrefix ), "&x04%s", g_iConfig[ SYSTEM_PREFIX ] );
	CC_SetPrefix( szPrefix );
	
	g_iSayTxtMsg = get_user_msgid( "SayText" );
	
	remove_user_flags( SERVER_ID, read_flags( "z" ) );	
	register_concmd( g_iConfig[ COMMAND_ADDADMIN ], "OnAddNewAdmin" );
	
	RegisterHam( Ham_Spawn, "player", "@Ham_Spawn_Post", 1 );
	RegisterHam( Ham_Killed, "player", "@Ham_Killed_Post", 1 );
	
	if( g_iConfig[ TEAM_SAY ] )
	{
		register_clcmd( "say", "OnHookSay" );
		register_clcmd( "say_team", "OnHookSayTeam" );
	}
	
	else
	{
		register_clcmd( "say", "OnHookSay" );
		register_clcmd( "say_team", "OnHookSay" );
	}
	
	register_cvar( "eas_version", szVersion, FCVAR_SERVER | FCVAR_SPONLY | FCVAR_UNLOGGED );

	set_task( g_iConfig[ FREQUENCY_UPDATE_ALL_FILES ], "OnTaskReloadAdmins", .flags="b" );
	
	g_iFwAdminAdded = CreateMultiForward( "AdminAdded", ET_IGNORE, FP_STRING, FP_STRING, FP_STRING, FP_STRING, FP_STRING, FP_STRING, FP_CELL, FP_STRING, FP_STRING, FP_CELL );

	if( g_iConfig[ ENABLE_MODELS ] )
	{
		register_forward( FM_SetClientKeyValue, "fw_SetClientKeyValue" );
	}
	register_event( "SayText" , "EventSayText" , "a" , "2=#Cstrike_Name_Change" );
}

public plugin_natives( )
{
	register_library( "eas_main" );
	
	register_native( "RegisterCommand", "OnNativeRegisterCommand" );
	register_native( "AddNewUser", "OnNativeAddNewUser" );
}

public OnNativeAddNewUser( iPlugin, iParams )
{
	new szID[ MAX_AUTHID_LENGTH ], szPassword[ MAX_PASSWORD_LENGTH ], szFlags[ MAX_FLAGS_LENGTH ], szPrefix[ 32 ], szSkinT[ 32 ], szSkinCT[ 32 ], iImmunity, bool:bKeepPrivileges, szExpireFlags[ MAX_FLAGS_LENGTH ], szExpire[ MAX_DATE_LENGTH ];
	get_string( 1, szID, charsmax( szID ) );
	get_string( 2, szPassword, charsmax( szPassword ) );
	get_string( 3, szFlags, charsmax( szFlags ) );
	get_string( 4, szPrefix, charsmax( szPrefix ) );
	get_string( 5, szSkinT, charsmax( szSkinT ) );
	get_string( 6, szSkinCT, charsmax( szSkinCT ) );
	iImmunity = get_param( 7 );
	get_string( 8, szExpire, charsmax( szExpire ) );
	get_string( 9, szExpireFlags, charsmax( szExpireFlags ) );
	bKeepPrivileges = bool:get_param( 10 );
	
	new szFormat[ 128 ];
	formatex( szFormat, charsmax( szFormat ), "%s/%s", g_szConfigsDir, g_iConfig[ USERS_FILE ] );
	new iFile = fopen( szFormat, "r+" );

	new szByteVal[ 1 ], szNewLine[ 128 ];
	
	fseek( iFile , -1 , SEEK_END );
	fread_raw( iFile , szByteVal , sizeof( szByteVal ) , BLOCK_BYTE );
	fseek( iFile , 0 , SEEK_END );
	
	formatex( szNewLine , charsmax( szNewLine ) , "%s^"%s^" ^"%s^" ^"%s^" ^"%s^" ^"%s^" ^"%s^" ^"%d^" ^"%s^" ^"%s^" ^"%d^"" , ( szByteVal[ 0 ] == 10 ) ? "" : "^n", szID, szPassword, szFlags, szPrefix, szSkinT, szSkinCT, iImmunity, szExpire, szExpireFlags, bKeepPrivileges );

	fprintf( iFile, szNewLine );
	fclose( iFile );
	
	new szAdminName[ MAX_NAME_LENGTH ];
	get_user_name( SERVER_ID, szAdminName, charsmax( szAdminName ) );
	
	send_message( 0, LOG, false, "%L", LANG_PLAYER, "LOG_ADDED_NEW_ADMIN", szAdminName, szAdminName, szID, szPassword, szFlags, szPrefix, szSkinT, szSkinCT, iImmunity, szExpire, szExpireFlags, bKeepPrivileges );
	ExecuteForward( g_iFwAdminAdded, g_iDummyResult, szID, szPassword, szFlags, szPrefix, szSkinT, szSkinCT, iImmunity, szExpireFlags, bKeepPrivileges );
}

public OnNativeRegisterCommand( iPlugin, iParams )
{
	new eData[ Commands ], szHandler[ 32 ];
	
	get_string( 1, eData[ Cmd_Name ], charsmax( eData[ Cmd_Name ] ) );
	get_string( 2, szHandler, charsmax( szHandler ) );
	
	eData[ Cmd_Flags ] = get_param( 3 );
	eData[ Cmd_Immunity ] = get_param( 4 );
	eData[ Cmd_Plugin ] = iPlugin;
	eData[ Cmd_FuncId ] = get_func_id( szHandler, iPlugin );
	
	ArrayPushArray( g_aCommands, eData );
}

public client_connect( id )
{
	g_bConnected[ id ] = true;
}

@Ham_Spawn_Post( id )
{
	if( ! is_user_alive( id ) )
	{
		g_bAlive[ id ] = false;
	}
	g_bAlive[ id ] = true;
	return HAM_IGNORED;
}

@Ham_Killed_Post( iVictim )
{
	g_bAlive[ iVictim ] = false;
}

public EventSayText( )
{
	g_iInfoChangedFwd = register_forward( FM_ClientUserInfoChanged, "ClientUserInfoChanged", 1 );
}

public ClientUserInfoChanged( id )
{
	if( g_bConnected[ id ] )
	{
		static szNewName[ MAX_NAME_LENGTH ];
		get_user_name( id, szNewName, charsmax( szNewName ) );
		
		unregister_forward( FM_ClientUserInfoChanged , g_iInfoChangedFwd, 1 );
		
		if( g_iConfig[ NAME_CHANGE_LOG ] )
		{
			send_message( 0, LOG, false, "%L", LANG_PLAYER, "NAME_CHANGE_LOG", g_szName[ id ], g_szAuthId[ id ], g_szIp[ id ], szNewName );
		}
		copy( g_szName[ id ], charsmax( g_szName[ ] ), szNewName );
	}
}

public FwdClientKill( id )
{
	if( ! g_bAlive[ id ] )
	{
		return FMRES_IGNORED;
	}
	return FMRES_SUPERCEDE;
}

public client_disconnect( id )
{
	if( g_iConfig[ ENABLE_MODELS ] )
	{
		g_bPersonalModel[ id ] = false;
		SetUserNotModeled( id );
	}
	
	g_bConnected[ id ] = false;
	g_bAlive[ id ] = false;
	
	remove_user_flags( id );
	set_user_flags( id, ADMIN_USER );
	
	arrayset( g_szName[ id ], 0, sizeof( g_szName[ ] ) );
	arrayset( g_szAuthId[ id ], 0, sizeof( g_szAuthId[ ] ) );
	arrayset( g_szIp[ id ], 0, sizeof( g_szIp[ ] ) );
}

public OnClassSelect( id )
{
	if( !g_bConnected[ id ] || g_iConfig[ SHOW_ADMIN_EXPIRE_DATE ] == 0 || g_iConfig[ SHOW_ADMIN_EXPIRE_DATE ] == 2 || ! IsPlayerPrivileged( id ) )
	{
		return PLUGIN_CONTINUE;
	}
	
	new eData[ PlayerData ], szRank[ 32 ];
	eas_get_player_rank( id, szRank, charsmax( szRank ) );
	
	if( ! szRank[ 0 ] )
	{
		return PLUGIN_CONTINUE;
	}
	
	if( TrieGetArray( g_tDatabase, g_szAuthId[ id ], eData, sizeof eData ) || TrieGetArray( g_tDatabase, g_szName[ id ], eData, sizeof eData ) )
	{
		if( eData[ Player_Expire_Date ][ 0 ] )
		{
			CC_SendMessage( id, "%L", id, "ADMIN_EXPIRE_DATE", szRank, eData[ Player_Expire_Date ] );
		}
		
		else
		{
			CC_SendMessage( id, "%L", id, "ADMIN_EXPIRE_DATE_NEVER", szRank );
		}
	}
	return PLUGIN_CONTINUE;
}

public OnAdminExpireDateShow( id )
{
	if( ! IsPlayerPrivileged( id ) )
	{
		return PLUGIN_HANDLED;
	}
	
	new eData[ PlayerData ], szRank[ 32 ];
	eas_get_player_rank( id, szRank, charsmax( szRank ) );
	
	if( ! szRank[ 0 ] )
	{
		return PLUGIN_HANDLED;
	}
	
	if( TrieGetArray( g_tDatabase, g_szAuthId[ id ], eData, sizeof eData ) || TrieGetArray( g_tDatabase, g_szName[ id ], eData, sizeof eData ) )
	{
		if( eData[ Player_Expire_Date ][ 0 ] )
		{
			CC_SendMessage( id, "%L", id, "ADMIN_EXPIRE_DATE", szRank, eData[ Player_Expire_Date ] );
		}
		
		else
		{
			CC_SendMessage( id, "%L", id, "ADMIN_EXPIRE_DATE_NEVER", szRank );
		}
	}
	return PLUGIN_HANDLED;
}

public fw_SetClientKeyValue( id, const szBuffer[ ], const szKey[ ], const szValue[ ] )
{
	if( !equal( szKey, "model" ) || !g_bConnected[ id ] || !g_iConfig[ ENABLE_MODELS ] )
	{
		return FMRES_IGNORED;
	}

	new iTeam = fm_cs_get_user_team_index( id );
	
	if( 1 <= iTeam <= 2 )
	{
		new szSupposedModel[ 64 ];
		if( g_bPersonalModel[ id ] )
		{
			TrieGetString( g_tPlayerModels[ iTeam - 1 ], g_szAuthId[ id ], szSupposedModel, charsmax( szSupposedModel ) );
		}
		
		else
		{
			iTeam == 1 ? copy( szSupposedModel, charsmax( szSupposedModel ), g_iConfig[ DEFAULT_MODEL_T ] ) : copy( szSupposedModel, charsmax( szSupposedModel ), g_iConfig[ DEFAULT_MODEL_CT ] );
		}
		
		if( szSupposedModel[ 0 ] && ModelExists( szSupposedModel ) )
		{
			if(	!IsUserModeled( id ) ||	!equal( g_szCurrentModel[ id ], szSupposedModel ) || !equal( szValue, szSupposedModel )	)
			{
				copy( g_szCurrentModel[ id ], charsmax( g_szCurrentModel[ ] ), szSupposedModel );
				SetUserModeled( id );
				
				set_user_info( id, "model", szSupposedModel );
				return FMRES_SUPERCEDE;
			}
		}
		
		if( IsUserModeled( id ) )
		{
			SetUserNotModeled( id );
			g_szCurrentModel[ id ][ 0 ] = 0;
		}
	}
	return FMRES_IGNORED;
}

public client_command( id )
{
	new szCommand[ 32 ];
	read_argv( 1, szCommand, charsmax( szCommand ) );
	
	new eData[ Commands ];
	for( new i; i < ArraySize( g_aCommands ); i++ )
	{
		ArrayGetArray( g_aCommands, i, eData );
		
		if( equali( szCommand, eData[ Cmd_Name ] ) )
		{			
			if( ~ get_user_flags( id ) & eData[ Cmd_Flags ] || GetImmunityLevel( id ) < eData[ Cmd_Immunity ] )
			{
				send_message( id, CONSOLE, true, "%L", id, "NO_ACCESS_COMMAND" );
				return PLUGIN_HANDLED;
			}
			
			callfunc_begin_i( eData[ Cmd_FuncId ], eData[ Cmd_Plugin ] );
			callfunc_push_int( id );
			callfunc_end( );
			
			return PLUGIN_HANDLED;
		}
	}
	return PLUGIN_CONTINUE;
}

public OnAddNewAdmin( id )
{
	if( ~ get_user_flags( id ) & g_iConfig[ ADMIN_ADD_FLAG ] )
	{
		send_message( id, CONSOLE, true, "%L", id, "NO_ACCESS_COMMAND" );
		return PLUGIN_HANDLED;
	}

	// authid size since it can be name or authid better to go with the biggest size
	new szPlayerIdentity[ MAX_AUTHID_LENGTH ], szPlayerPassword[ MAX_PASSWORD_LENGTH ], szPlayerFlags[ MAX_FLAGS_LENGTH ], szPlayerPrefix[ 32 ], szPlayerModelT[ 32 ], szPlayerModelCT[ 32 ], szPlayerImmunity[ 10 ], szPlayerExpireDate[ MAX_DATE_LENGTH ], szPlayerExpireFlags[ MAX_FLAGS_LENGTH ], szPlayerKeepPrivileges[ 3 ];
	
	read_argv( 1, szPlayerIdentity, charsmax( szPlayerIdentity ) );
	read_argv( 2, szPlayerPassword, charsmax( szPlayerPassword ) );
	read_argv( 3, szPlayerFlags, charsmax( szPlayerFlags ) );
	read_argv( 4, szPlayerPrefix, charsmax( szPlayerPrefix ) );
	read_argv( 5, szPlayerModelT, charsmax( szPlayerModelT ) );
	read_argv( 6, szPlayerModelCT, charsmax( szPlayerModelCT ) );
	read_argv( 7, szPlayerImmunity, charsmax( szPlayerImmunity ) );
	read_argv( 8, szPlayerExpireDate, charsmax( szPlayerExpireDate ) );
	read_argv( 9, szPlayerExpireFlags, charsmax( szPlayerExpireFlags ) );
	read_argv( 10, szPlayerKeepPrivileges, charsmax( szPlayerKeepPrivileges ) );
	
	if( read_argc( ) != 11 )
	{
		send_message( id, CONSOLE, true, "%L", id, "AMX_ADD_ADMIN_USAGE", g_iConfig[ COMMAND_ADDADMIN ] );
		return PLUGIN_HANDLED;
	}
	
	if( ! szPlayerIdentity[ 0 ] || ! szPlayerFlags[ 0 ] || is_str_num( szPlayerFlags ) || ! is_str_num( szPlayerImmunity ) || ! is_str_num( szPlayerKeepPrivileges ) )
	{
		send_message( id, CONSOLE, true, "%L", id, "INCORRECT_FORMAT" );
		return PLUGIN_HANDLED;
	}
	
	new iPlayerImmunity = str_to_num( szPlayerImmunity );
	new bool:bKeepPrivileges = bool:str_to_num( szPlayerKeepPrivileges );
	
	new szFormat[ 128 ];
	formatex( szFormat, charsmax( szFormat ), "%s/%s", g_szConfigsDir, g_iConfig[ USERS_FILE ] );
	new iFile = fopen( szFormat, "r+" );

	new szByteVal[ 1 ], szNewLine[ 128 ];
	
	fseek( iFile , -1 , SEEK_END );
	fread_raw( iFile , szByteVal , sizeof( szByteVal ) , BLOCK_BYTE );
	fseek( iFile , 0 , SEEK_END );
	
	formatex( szNewLine , charsmax( szNewLine ) , "%s^"%s^" ^"%s^" ^"%s^" ^"%s^" ^"%s^" ^"%s^" ^"%s^" ^"%s^" ^"%s^" ^"%s^"" , ( szByteVal[ 0 ] == 10 ) ? "" : "^n", szPlayerIdentity, szPlayerPassword, szPlayerFlags, szPlayerPrefix, szPlayerModelT, szPlayerModelCT, szPlayerImmunity, szPlayerExpireDate, szPlayerExpireFlags, szPlayerKeepPrivileges );

	fprintf( iFile, szNewLine );
	fclose( iFile );
	
	send_message( id, CONSOLE, false, "%L", id, "SUCCESSFULLY_ADD_NEW_ADMIN", szPlayerIdentity, szPlayerPassword, szPlayerFlags, szPlayerPrefix, szPlayerModelT, szPlayerModelCT, iPlayerImmunity, szPlayerExpireDate, szPlayerExpireFlags, bKeepPrivileges );
	send_message( 0, LOG, false, "%L", LANG_PLAYER, "LOG_ADDED_NEW_ADMIN", g_szName[ id ], g_szAuthId[ id ], szPlayerIdentity, szPlayerPassword, szPlayerFlags, szPlayerPrefix, szPlayerModelT, szPlayerModelCT, iPlayerImmunity, szPlayerExpireDate, szPlayerExpireFlags, bKeepPrivileges );
	
	ExecuteForward( g_iFwAdminAdded, g_iDummyResult, szPlayerIdentity, szPlayerPassword, szPlayerFlags, szPlayerPrefix, szPlayerModelT, szPlayerModelCT, iPlayerImmunity, szPlayerExpireDate, szPlayerExpireFlags, bKeepPrivileges );
	
	return PLUGIN_CONTINUE;
}

public client_putinserver( id )
{
	remove_user_flags( id );
	set_user_flags( id, ADMIN_USER );

	get_user_authid( id, g_szAuthId[ id ], charsmax( g_szAuthId[ ] ) );
	get_user_name( id, g_szName[ id ], charsmax( g_szName[ ] ) );
	get_user_ip( id, g_szIp[ id ], charsmax( g_szIp[ ] ), 1 );

	CheckPlayerAdmin( id );
}

public client_authorized( id )
{
	remove_user_flags( id );
	set_user_flags( id, ADMIN_USER );

	get_user_authid( id, g_szAuthId[ id ], charsmax( g_szAuthId[ ] ) );
	get_user_name( id, g_szName[ id ], charsmax( g_szName[ ] ) );
	get_user_ip( id, g_szIp[ id ], charsmax( g_szIp[ ] ), 1 );

	CheckPlayerAdmin( id );
	
	if( g_iConfig[ CONNECT_LOG ] )
	{
		send_message( 0, LOG, false, "%L", LANG_PLAYER, "CONNECT_LOG", g_szName[ id ], g_szAuthId[ id ], g_szIp[ id ] );
	}

	if( TrieKeyExists( g_tPlayerModels[ 0 ], g_szAuthId[ id ] ) || TrieKeyExists( g_tPlayerModels[ 1 ], g_szAuthId[ id ] ) )
	{
		g_bPersonalModel[ id ] = true;
	}
	
	else
	{
		g_bPersonalModel[ id ] = false;
	}
}

public OnTaskReloadAdmins( )
{
	ReloadFile( );
	
	static iPlayers[ 32 ], iNum, iTempID;
	get_players( iPlayers, iNum, "ch" );

	for( new i; i < iNum; i++ )
	{
		iTempID = iPlayers[ i ];

		CheckPlayerAdmin( iTempID );
	}
}

public OnHookSay( id )
{
	if( ! is_user_connected( id ) )
	{
		return PLUGIN_HANDLED;
	}

	new szArgs[ MAX_TEXT_LENGTH ];
	read_args( szArgs, charsmax( szArgs ) );
	
	remove_quotes( szArgs );
	trim( szArgs );
	
	if( ! szArgs[ 0 ] )
	{
		return PLUGIN_HANDLED;
	}
	
	if( szArgs[ 0 ] == '@' ) // admin chat
	{
		format( szArgs, charsmax( szArgs ), "%s", szArgs[ 1 ] ); // remove the @ from the msg
		trim( szArgs ); // remove blank spaces
		
		if( ! szArgs[ 0 ] )
		{
			return PLUGIN_HANDLED;
		}
		
		new iPlayers[ MAX_PLAYERS ], iNum, iTempId;
		get_players( iPlayers, iNum, "ch" );
		
		for( new i; i < iNum; i++ )
		{
			iTempId = iPlayers[ i ];
			
			if( get_user_flags( iTempId ) & g_iConfig[ CHAT_FLAG ] )
			{
				CC_SendMatched( iTempId, id, "&x00%L", iTempId, "ADMIN_CHAT_SAY", g_szName[ id ], szArgs );
			}
		}
		
		if( g_iConfig[ CHAT_LOG ] )
		{
			send_message( 0, LOG, false, "&x00%L", LANG_PLAYER, "SAY_CHAT_LOG_ADMIN", g_szName[ id ], g_szAuthId[ id ], g_szIp[ id ], szArgs );
		}
		return PLUGIN_HANDLED;
	}
	
	else
	{
		if( g_iConfig[ CHAT_LOG ] )
		{
			send_message( 0, LOG, false, "%L", LANG_PLAYER, "SAY_CHAT_LOG", g_szName[ id ], g_szAuthId[ id ], g_szIp[ id ], szArgs );
		}
		
		new szPassword[ MAX_PASSWORD_LENGTH ], eData[ PlayerData ], szRank[ 32 ], iPlayers[ MAX_PLAYERS ], iNum, i, iTempId, szMessage[ MAX_TEXT_LENGTH ], iTeam, bool:bAlive = bool:g_bAlive[ id ];
		eas_get_player_rank( id, szRank, charsmax( szRank ) );
		get_user_info( id, "_pw", szPassword, charsmax( szPassword ) );
		get_players( iPlayers, iNum, "ch" );
		
		iTeam = fm_cs_get_user_team_index( id );
		
		if( TrieGetArray( g_tDatabase, g_szAuthId[ id ], eData, sizeof eData ) || TrieGetArray( g_tDatabase, g_szName[ id ], eData, sizeof eData ) )
		{
			if( equal( eData[ Player_Password ], szPassword ) || eData[ Player_Password ][ 0 ] == EOS ) // correct password or no password at all
			{
				if( eData[ Player_Suspended ] || ( eData[ Player_Expired ] && !eData[ Player_KeepPrivileges ] ) )
				{
					switch( iTeam )
					{
					case 1, 2:
						{
							if( ! bAlive )
							{
								formatex( szMessage, charsmax( szMessage ), "^1%s ^3%s ^1: %s", g_iConfig[ DEAD_PREFIX ], g_szName[ id ], szArgs );
							}
							
							else
							{
								formatex( szMessage, charsmax( szMessage ), "^3%s ^1: %s", g_szName[ id ], szArgs );
							}
						}
						
					case 3:
						{
							formatex( szMessage, charsmax( szMessage ), "^1%s ^3%s ^1: %s", g_iConfig[ SPECTATOR_PREFIX ], g_szName[ id ], szArgs );
						}
					}
					
					for( i = 0; i < iNum; i++ )
					{
						iTempId = iPlayers[ i ];
						
						Print_Message( szMessage, id, iTempId );
					}
					return PLUGIN_HANDLED_MAIN;
				}
				
				else
				{
					switch( iTeam )
					{
					case 1, 2:
						{
							switch( g_iConfig[ RANKS_IN_CHAT ] )
							{
							case 0: // ranks off
								{
									if( eData[ Player_Prefix ][ 0 ] )
									{
										if( bAlive )
										{
											formatex( szMessage, charsmax( szMessage ), "^4%s ^3%s ^1: %s", eData[ Player_Prefix ], g_szName[ id ], szArgs );
										}
										
										else
										{
											formatex( szMessage, charsmax( szMessage ), "^1%s ^4%s ^3%s ^1: %s", g_iConfig[ DEAD_PREFIX ], eData[ Player_Prefix ], g_szName[ id ], szArgs );
										}
										
										for( i = 0; i < iNum; i++ )
										{
											iTempId = iPlayers[ i ];
											
											Print_Message( szMessage, id, iTempId );
										}
									}
									
									else
									{
										if( ! bAlive )
										{
											formatex( szMessage, charsmax( szMessage ), "^1%s ^3%s ^1: %s", g_iConfig[ DEAD_PREFIX ], g_szName[ id ], szArgs );
										}
										
										else
										{
											formatex( szMessage, charsmax( szMessage ), "^3%s ^1: %s", g_szName[ id ], szArgs );
										}
										
										for( i = 0; i < iNum; i++ )
										{
											iTempId = iPlayers[ i ];
											
											Print_Message( szMessage, id, iTempId );
										}
									}
									return PLUGIN_HANDLED_MAIN;
								}
								
							case 1: // ranks on
								{
									if( eData[ Player_Prefix ][ 0 ] || szRank[ 0 ] )
									{
										if( bAlive )
										{
											if( eData[ Player_Prefix ][ 0 ] )
											{
												formatex( szMessage, charsmax( szMessage ), "^4%s%s%s%s%s ^3%s ^1: %s", szRank[ 0 ] ? "[" : "", szRank[ 0 ] ? szRank : "", szRank[ 0 ] ? "]" : "", szRank[ 0 ] ? " " : "", eData[ Player_Prefix ], g_szName[ id ], szArgs );
											}
											
											else
											{
												formatex( szMessage, charsmax( szMessage ), "^4%s%s%s%s^3%s ^1: %s", szRank[ 0 ] ? "[" : "", szRank[ 0 ] ? szRank : "", szRank[ 0 ] ? "]" : "", szRank[ 0 ] ? " " : "", g_szName[ id ], szArgs );
											}
										}
										
										else
										{
											if( eData[ Player_Prefix ][ 0 ] )
											{
												formatex( szMessage, charsmax( szMessage ), "^1%s ^4%s%s%s%s%s ^3%s ^1: %s", g_iConfig[ DEAD_PREFIX ], szRank[ 0 ] ? "[" : "", szRank[ 0 ] ? szRank : "", szRank[ 0 ] ? "]" : "", szRank[ 0 ] ? " " : "", eData[ Player_Prefix ], g_szName[ id ], szArgs );
											}
											
											else
											{
												formatex( szMessage, charsmax( szMessage ), "^1%s ^4%s%s%s%s^3%s ^1: %s", g_iConfig[ DEAD_PREFIX ], szRank[ 0 ] ? "[" : "", szRank[ 0 ] ? szRank : "", szRank[ 0 ] ? "]" : "", szRank[ 0 ] ? " " : "", g_szName[ id ], szArgs );
											}
										}
										
										for( i = 0; i < iNum; i++ )
										{
											iTempId = iPlayers[ i ];
											
											Print_Message( szMessage, id, iTempId );
										}
									}
									
									else
									{
										if( ! bAlive )
										{
											formatex( szMessage, charsmax( szMessage ), "^1%s ^3%s ^1: %s", g_iConfig[ DEAD_PREFIX ], g_szName[ id ], szArgs );
										}
										
										else
										{
											formatex( szMessage, charsmax( szMessage ), "^3%s ^1: %s", g_szName[ id ], szArgs );
										}
										
										for( i = 0; i < iNum; i++ )
										{
											iTempId = iPlayers[ i ];
											
											Print_Message( szMessage, id, iTempId );
										}
									}
									return PLUGIN_HANDLED_MAIN;
								}
							}
						}
						
					case 3:
						{
							switch( g_iConfig[ RANKS_IN_CHAT ] )
							{
							case 0: // ranks off
								{
									if( eData[ Player_Prefix ][ 0 ] )
									{
										formatex( szMessage, charsmax( szMessage ), "^1%s ^4%s ^3%s ^1: %s", g_iConfig[ SPECTATOR_PREFIX ], eData[ Player_Prefix ], g_szName[ id ], szArgs );												
										
										for( i = 0; i < iNum; i++ )
										{
											iTempId = iPlayers[ i ];
											
											Print_Message( szMessage, id, iTempId );
										}
									}
									
									else
									{
										formatex( szMessage, charsmax( szMessage ), "^1%s ^3%s ^1: %s", g_iConfig[ SPECTATOR_PREFIX ], g_szName[ id ], szArgs );
										
										for( i = 0; i < iNum; i++ )
										{
											iTempId = iPlayers[ i ];
											
											Print_Message( szMessage, id, iTempId );
										}
									}
									return PLUGIN_HANDLED_MAIN;
								}
								
							case 1:
								{
									if( eData[ Player_Prefix ][ 0 ] || szRank[ 0 ] )
									{
										if( eData[ Player_Prefix ][ 0 ] )
										{
											formatex( szMessage, charsmax( szMessage ), "^1%s ^4%s%s%s %s%s^3%s ^1: %s", g_iConfig[ SPECTATOR_PREFIX ], szRank[ 0 ] ? "[" : "", szRank[ 0 ] ? szRank : "", szRank[ 0 ] ? "]" : "", eData[ Player_Prefix ], eData[ Player_Prefix ][ 0 ] ? " " : "", g_szName[ id ], szArgs );
										}
										
										else
										{
											formatex( szMessage, charsmax( szMessage ), "^1%s ^4%s%s%s ^3%s ^1: %s", g_iConfig[ SPECTATOR_PREFIX ], szRank[ 0 ] ? "[" : "", szRank[ 0 ] ? szRank : "", szRank[ 0 ] ? "]" : "", g_szName[ id ], szArgs );
										}
										
										for( i = 0; i < iNum; i++ )
										{
											iTempId = iPlayers[ i ];
											
											Print_Message( szMessage, id, iTempId );
										}
									}
									
									else
									{
										formatex( szMessage, charsmax( szMessage ), "^1%s ^3%s ^1: %s", g_iConfig[ SPECTATOR_PREFIX ], g_szName[ id ], szArgs );
										
										for( i = 0; i < iNum; i++ )
										{
											iTempId = iPlayers[ i ];
											
											Print_Message( szMessage, id, iTempId );
										}
									}
									return PLUGIN_HANDLED_MAIN;
								}
							}
						}
					}
				}
			}
		}
	}
	return PLUGIN_CONTINUE;
}

public OnHookSayTeam( id )
{
	if( ! is_user_connected( id ) )
	{
		return PLUGIN_HANDLED;
	}

	new szArgs[ MAX_TEXT_LENGTH ];
	read_args( szArgs, charsmax( szArgs ) );
	
	remove_quotes( szArgs );
	trim( szArgs );
	
	if( ! szArgs[ 0 ] )
	{
		return PLUGIN_HANDLED;
	}
	
	if( szArgs[ 0 ] == '@' ) // admin chat
	{
		format( szArgs, charsmax( szArgs ), "%s", szArgs[ 1 ] ); // remove the @ from the msg
		trim( szArgs ); // remove blank spaces
		
		if( ! szArgs[ 0 ] )
		{
			return PLUGIN_HANDLED;
		}
		
		new iPlayers[ MAX_PLAYERS ], iNum, iTempId;
		get_players( iPlayers, iNum, "ch" );
		
		for( new i; i < iNum; i++ )
		{
			iTempId = iPlayers[ i ];
			
			if( get_user_flags( iTempId ) & g_iConfig[ CHAT_FLAG ] )
			{
				CC_SendMatched( iTempId, id, "&x00%L", iTempId, "ADMIN_CHAT_SAY", g_szName[ id ], szArgs );
			}
		}
		
		if( g_iConfig[ CHAT_LOG ] )
		{
			send_message( 0, LOG, false, "&x00%L", LANG_PLAYER, "SAY_CHAT_LOG_ADMIN", g_szName[ id ], g_szAuthId[ id ], g_szIp[ id ], szArgs );
		}
		return PLUGIN_HANDLED;
	}
	
	else
	{
		if( g_iConfig[ CHAT_LOG ] )
		{
			send_message( 0, LOG, false, "%L", LANG_PLAYER, "SAY_CHAT_LOG", g_szName[ id ], g_szAuthId[ id ], g_szIp[ id ], szArgs );
		}
		
		new szPassword[ MAX_PASSWORD_LENGTH ], eData[ PlayerData ], szRank[ 32 ], szTeamName[ 24 ], iPlayers[ MAX_PLAYERS ], iNum, i, iTempId, szMessage[ MAX_TEXT_LENGTH ], iTeam, bool:bAlive = bool:g_bAlive[ id ];
		eas_get_player_rank( id, szRank, charsmax( szRank ) );
		get_user_info( id, "_pw", szPassword, charsmax( szPassword ) );
		get_players( iPlayers, iNum, "ch" );
		
		iTeam = fm_cs_get_user_team_index( id );
		GetTeamName( iTeam, szTeamName, charsmax( szTeamName ) );
		
		if( TrieGetArray( g_tDatabase, g_szAuthId[ id ], eData, sizeof eData ) || TrieGetArray( g_tDatabase, g_szName[ id ], eData, sizeof eData ) )
		{
			if( equal( eData[ Player_Password ], szPassword ) || eData[ Player_Password ][ 0 ] == EOS ) // correct password or no password at all
			{
				if( eData[ Player_Suspended ] || ( eData[ Player_Expired ] && !eData[ Player_KeepPrivileges ] ) )
				{
					switch( iTeam )
					{
					case 1, 2:
						{
							if( ! bAlive )
							{
								formatex( szMessage, charsmax( szMessage ), "^1%s ^1(%s) ^3%s ^1: %s", g_iConfig[ DEAD_PREFIX ], szTeamName, g_szName[ id ], szArgs );
							}
							
							else
							{
								formatex( szMessage, charsmax( szMessage ), "^1(%s) ^3%s ^1: %s", szTeamName, g_szName[ id ], szArgs );
							}
						}
						
					case 3:
						{
							formatex( szMessage, charsmax( szMessage ), "^1%s ^1(Spectator) ^3%s ^1: %s", g_iConfig[ SPECTATOR_PREFIX ], g_szName[ id ], szArgs );
						}
					}
					
					for( i = 0; i < iNum; i++ )
					{
						iTempId = iPlayers[ i ];
						
						if( fm_cs_get_user_team_index( iTempId ) == iTeam )
						{
							Print_Message( szMessage, id, iTempId );
						}
					}
					return PLUGIN_HANDLED_MAIN;
				}
				
				else
				{
					switch( iTeam )
					{
					case 1, 2:
						{
							switch( g_iConfig[ RANKS_IN_CHAT ] )
							{
							case 0: // ranks off
								{
									if( eData[ Player_Prefix ][ 0 ] )
									{
										if( bAlive )
										{
											formatex( szMessage, charsmax( szMessage ), "^1(%s) ^4%s ^3%s ^1: %s", szTeamName, eData[ Player_Prefix ], g_szName[ id ], szArgs );
										}
										
										else
										{
											formatex( szMessage, charsmax( szMessage ), "^1%s ^1(%s) ^4%s ^3%s ^1: %s", g_iConfig[ DEAD_PREFIX ], szTeamName, eData[ Player_Prefix ], g_szName[ id ], szArgs );
										}
										
										for( i = 0; i < iNum; i++ )
										{
											iTempId = iPlayers[ i ];
											
											if( fm_cs_get_user_team_index( iTempId ) == iTeam )
											{
												Print_Message( szMessage, id, iTempId );
											}
										}
										return PLUGIN_HANDLED_MAIN;
									}
								}
								
							case 1: // ranks on
								{
									if( eData[ Player_Prefix ][ 0 ] || szRank[ 0 ] )
									{
										if( bAlive )
										{
											if( eData[ Player_Prefix ][ 0 ] )
											{
												formatex( szMessage, charsmax( szMessage ), "^1(%s) ^4%s%s%s%s%s ^3%s ^1: %s", szTeamName, szRank[ 0 ] ? "[" : "", szRank[ 0 ] ? szRank : "", szRank[ 0 ] ? "]" : "", szRank[ 0 ] ? " " : "", eData[ Player_Prefix ], g_szName[ id ], szArgs );
											}
											
											else
											{
												formatex( szMessage, charsmax( szMessage ), "^1(%s) ^4%s%s%s%s^3%s ^1: %s", szTeamName, szRank[ 0 ] ? "[" : "", szRank[ 0 ] ? szRank : "", szRank[ 0 ] ? "]" : "", szRank[ 0 ] ? " " : "", g_szName[ id ], szArgs );
											}
										}
										
										else
										{
											if( eData[ Player_Prefix ][ 0 ] )
											{
												formatex( szMessage, charsmax( szMessage ), "^1%s ^1(%s) ^4%s%s%s%s%s ^3%s ^1: %s", g_iConfig[ DEAD_PREFIX ], szTeamName, szRank[ 0 ] ? "[" : "", szRank[ 0 ] ? szRank : "", szRank[ 0 ] ? "]" : "", szRank[ 0 ] ? " " : "", eData[ Player_Prefix ], g_szName[ id ], szArgs );
											}
											
											else
											{
												formatex( szMessage, charsmax( szMessage ), "^1%s ^1(%s) ^4%s%s%s%s^3%s ^1: %s", g_iConfig[ DEAD_PREFIX ], szTeamName, szRank[ 0 ] ? "[" : "", szRank[ 0 ] ? szRank : "", szRank[ 0 ] ? "]" : "", szRank[ 0 ] ? " " : "", g_szName[ id ], szArgs );
											}
										}
										
										for( i = 0; i < iNum; i++ )
										{
											iTempId = iPlayers[ i ];
											
											if( fm_cs_get_user_team_index( iTempId ) == iTeam )
											{
												Print_Message( szMessage, id, iTempId );
											}
										}
										return PLUGIN_HANDLED_MAIN;
									}
								}
							}
						}
						
					case 3:
						{
							switch( g_iConfig[ RANKS_IN_CHAT ] )
							{
							case 0: // ranks off
								{
									if( eData[ Player_Prefix ][ 0 ] )
									{
										formatex( szMessage, charsmax( szMessage ), "^1%s ^1(Spectator) ^4%s ^3%s ^1: %s", g_iConfig[ SPECTATOR_PREFIX ], eData[ Player_Prefix ], g_szName[ id ], szArgs );												
										
										for( i = 0; i < iNum; i++ )
										{
											iTempId = iPlayers[ i ];
											
											if( fm_cs_get_user_team_index( iTempId ) == iTeam )
											{
												Print_Message( szMessage, id, iTempId );
											}
										}
										return PLUGIN_HANDLED_MAIN;
									}
								}
								
							case 1:
								{
									if( eData[ Player_Prefix ][ 0 ] || szRank[ 0 ] )
									{
										if( eData[ Player_Prefix ][ 0 ] )
										{
											formatex( szMessage, charsmax( szMessage ), "^1%s ^1(Spectator) ^4%s%s%s %s%s^3%s ^1: %s", g_iConfig[ SPECTATOR_PREFIX ], szRank[ 0 ] ? "[" : "", szRank[ 0 ] ? szRank : "", szRank[ 0 ] ? "]" : "", eData[ Player_Prefix ], eData[ Player_Prefix ][ 0 ] ? " " : "", g_szName[ id ], szArgs );
										}
										
										else
										{
											formatex( szMessage, charsmax( szMessage ), "^1%s ^1(Spectator) ^4%s%s%s ^3%s ^1: %s", g_iConfig[ SPECTATOR_PREFIX ], szRank[ 0 ] ? "[" : "", szRank[ 0 ] ? szRank : "", szRank[ 0 ] ? "]" : "", g_szName[ id ], szArgs );
										}
										
										for( i = 0; i < iNum; i++ )
										{
											iTempId = iPlayers[ i ];
											
											if( fm_cs_get_user_team_index( iTempId ) == iTeam )
											{
												Print_Message( szMessage, id, iTempId );
											}
										}
										return PLUGIN_HANDLED_MAIN;
									}
								}
							}
						}
					}
				}
			}
		}
	}
	return PLUGIN_CONTINUE;
}

CheckPlayerAdmin( id )
{
	new szPassword[ MAX_PASSWORD_LENGTH ], eData[ PlayerData ];
	get_user_info( id, "_pw", szPassword, charsmax( szPassword ) );
	
	if( TrieGetArray( g_tDatabase, g_szName[ id ], eData, sizeof eData ) )
	{
		if( ( eData[ Player_Password ][ 0 ] && equal( eData[ Player_Password ], szPassword ) ) || !eData[ Player_Password ][ 0 ] )
		{
			if( eData[ Player_Suspended ] || ( eData[ Player_Expired ] && !eData[ Player_KeepPrivileges ] ) )
			{
				remove_user_flags( id );
				set_user_flags( id, ADMIN_USER );
				
				return PLUGIN_HANDLED;
			}
			
			else if( eData[ Player_Expired ] && eData[ Player_KeepPrivileges ] )
			{
				remove_user_flags( id );
				
				if( ! eData[ Player_AccessFlags ][ 0 ] )
				{
					set_user_flags( id, ADMIN_USER );
					return PLUGIN_HANDLED;
				} 
				
				new iFlags = read_flags( eData[ Player_AccessFlags ] );
				iFlags &= ~read_flags( eData[ Player_FlagsExpire ] );
				
				if( ! iFlags )
				{
					set_user_flags( id, ADMIN_USER );
				}
				
				else
				{
					set_user_flags( id, iFlags );
				}
				return PLUGIN_HANDLED;
			}
			
			else
			{
				remove_user_flags( id );
				
				if( ! eData[ Player_AccessFlags ][ 0 ] )
				{
					set_user_flags( id, ADMIN_USER );
				}
				
				else
				{
					set_user_flags( id, read_flags( eData[ Player_AccessFlags ] ) );
				}
				return PLUGIN_HANDLED;
			}
		}
		
		else if( eData[ Player_Password ][ 0 ] && !equal( eData[ Player_Password ], szPassword ) )
		{
			server_cmd( "kick #%d ^"%L^"", get_user_userid( id ), LANG_PLAYER, "INCORRECT_PASSWORD" );
			return PLUGIN_HANDLED;
		}
	}
	
	if( TrieGetArray( g_tDatabase, g_szAuthId[ id ], eData, sizeof eData ) )
	{
		if( ( eData[ Player_Password ][ 0 ] && equal( eData[ Player_Password ], szPassword ) ) || !eData[ Player_Password ][ 0 ] )
		{
			if( eData[ Player_Suspended ] || ( eData[ Player_Expired ] && !eData[ Player_KeepPrivileges ] ) )
			{
				remove_user_flags( id );
				set_user_flags( id, ADMIN_USER );
				
				return PLUGIN_HANDLED;
			}
			
			else if( eData[ Player_Expired ] && eData[ Player_KeepPrivileges ] )
			{
				remove_user_flags( id );
				
				if( ! eData[ Player_AccessFlags ][ 0 ] )
				{
					set_user_flags( id, ADMIN_USER );
					return PLUGIN_HANDLED;
				} 
				
				new iFlags = read_flags( eData[ Player_AccessFlags ] );
				iFlags &= ~read_flags( eData[ Player_FlagsExpire ] );
				
				if( ! iFlags )
				{
					set_user_flags( id, ADMIN_USER );
				}
				
				else
				{
					set_user_flags( id, iFlags );
				}
				return PLUGIN_HANDLED;
			}
			
			else
			{
				remove_user_flags( id );
				
				if( ! eData[ Player_AccessFlags ][ 0 ] )
				{
					set_user_flags( id, ADMIN_USER );
				}
				
				else
				{
					set_user_flags( id, read_flags( eData[ Player_AccessFlags ] ) );
				}
				return PLUGIN_HANDLED;
			}
		}
		
		else if( eData[ Player_Password ][ 0 ] && !equal( eData[ Player_Password ], szPassword ) )
		{
			server_cmd( "kick #%d ^"%L^"", get_user_userid( id ), LANG_PLAYER, "INCORRECT_PASSWORD" );
			return PLUGIN_HANDLED;
		}
	}
	
	return PLUGIN_CONTINUE;
}

ReloadFile( )
{
	TrieClear( g_tDatabase );
	ArrayClear( g_aTrieKeys );

	new szFormat[ 64 ], szPlayerData[ 512 ], eData[ PlayerData ];
	formatex( szFormat, charsmax( szFormat ), "%s/%s", g_szConfigsDir, g_iConfig[ USERS_FILE ] );
	
	new iFile = fopen( szFormat, "rt" );
	
	if( iFile )
	{
		while( fgets( iFile, szPlayerData, charsmax( szPlayerData ) ) )
		{
			trim( szPlayerData );
			
			switch( szPlayerData[ 0 ] )
			{
			case EOS, '#', '/', '\':
				{
					continue;
				}
				
			default:
				{
					new szImmunity[ 8 ], szKeepPrivileges[ 3 ];
					if( parse( szPlayerData, eData[ Player_Name ], charsmax( eData[ Player_Name ] ), eData[ Player_SteamID ], charsmax( eData[ Player_SteamID ] ), eData[ Player_Password ], charsmax( eData[ Player_Password ] ), eData[ Player_AccessFlags ], charsmax( eData[ Player_AccessFlags ] ),
								eData[ Player_Prefix ], charsmax( eData[ Player_Prefix ] ), eData[ Player_Model_T ], charsmax( eData[ Player_Model_T ] ), eData[ Player_Model_CT ], charsmax( eData[ Player_Model_CT ] ), szImmunity, charsmax( szImmunity ),
								eData[ Player_Expire_Date ], charsmax( eData[ Player_Expire_Date ] ), eData[ Player_FlagsExpire ], charsmax( eData[ Player_FlagsExpire ] ), szKeepPrivileges, charsmax( szKeepPrivileges ) ) < 11 )
					{
						continue;
					}
					
					if( szPlayerData[ 0 ] == ';' )
					{
						eData[ Player_Suspended ] = true;
						replace( eData[ Player_Name ], charsmax( eData[ Player_Name ] ), ";", "" );
					}
					
					if( eData[ Player_Expire_Date ][ 0 ] )
					{
						if( HasAdminExpired( eData[ Player_Expire_Date ] ) )
						{
							eData[ Player_Expired ] = true;
						}
					}
					
					// we don't want to use models that don't exist
					if( eData[ Player_Model_T ][ 0 ] )
					{
						if( ! ModelExists( eData[ Player_Model_T ] ) )
						{
							eData[ Player_Model_T ][ 0 ] = EOS;
						}
					}
					
					if( eData[ Player_Model_CT ][ 0 ] )
					{
						if( ! ModelExists( eData[ Player_Model_CT ] ) )
						{
							eData[ Player_Model_CT ][ 0 ] = EOS;
						}
					}
					
					new iImmunity = str_to_num( szImmunity );
					eData[ Player_Immunity ] = ( ! is_str_num( szImmunity ) || iImmunity < 0 ) ? 0 : iImmunity;
					
					new iKeepPrivileges = str_to_num( szKeepPrivileges );
					eData[ Player_KeepPrivileges ] = bool:( ( ! is_str_num( szKeepPrivileges ) || !( 0 <= iKeepPrivileges <= 1 ) ) ? 0 : iKeepPrivileges );
										
					if( eData[ Player_SteamID ][ 0 ] )
					{
						TrieSetArray( g_tDatabase, eData[ Player_SteamID ], eData, sizeof eData );
						ArrayPushString( g_aTrieKeys, eData[ Player_SteamID ] );
					}
					
					if( eData[ Player_Name ][ 0 ] )
					{
						TrieSetArray( g_tDatabase, eData[ Player_Name ], eData, sizeof eData );
						ArrayPushString( g_aTrieKeys, eData[ Player_Name ] );
					}
					arrayset( eData, 0, sizeof( eData ) );
				}
			}
		}
		fclose( iFile );
	}
}

ReadConfig( )
{
	new szFile[ 128 ], szData[ 64 ];
	formatex( szFile, charsmax( szFile ), "%s/%s", g_szConfigsDir, g_szConfigFile );
	
	new iFile = fopen( szFile, "rt" );
	
	if( iFile )
	{
		while( fgets( iFile, szData, charsmax( szData ) ) )
		{
			trim( szData );
			remove_quotes( szData );
			
			switch( szData[ 0 ] )
			{
			case EOS, '#', ';', '/', '\':
				{
					continue;
				}

			default:
				{
					new szKey[ 32 ], szValue[ 32 ];
					strtok( szData, szKey, charsmax( szKey ), szValue, charsmax( szValue ), '=' );
					
					trim( szKey );
					trim( szValue );
					
					remove_quotes( szKey );
					remove_quotes( szValue );
					
					if( ! szValue[ 0 ] || ! szKey[ 0 ] )
					{
						continue;
					}
					
					if( equali( szKey, "DEAD_PREFIX" ) )
					{
						copy( g_iConfig[ DEAD_PREFIX ], charsmax( g_iConfig[ DEAD_PREFIX ] ), szValue );
					}
					
					else if( equali( szKey, "SPECTATOR_PREFIX" ) )
					{
						copy( g_iConfig[ SPECTATOR_PREFIX ], charsmax( g_iConfig[ SPECTATOR_PREFIX ] ), szValue );
					}
					
					else if( equali( szKey, "COMMAND_ADDADMIN" ) )
					{
						copy( g_iConfig[ COMMAND_ADDADMIN ], charsmax( g_iConfig[ COMMAND_ADDADMIN ] ), szValue );
					}
					
					else if( equali( szKey, "ADMIN_ADD_FLAG" ) )
					{
						g_iConfig[ ADMIN_ADD_FLAG ] = read_flags( szValue );
					}
					
					else if( equali( szKey, "USERS_FILE" ) )
					{
						copy( g_iConfig[ USERS_FILE ], charsmax( g_iConfig[ USERS_FILE ] ), szValue );
					}
					
					else if( equali( szKey, "SYSTEM_PREFIX" ) )
					{
						copy( g_iConfig[ SYSTEM_PREFIX ], charsmax( g_iConfig[ SYSTEM_PREFIX ] ), szValue );
					}
					
					else if( equali( szKey, "FREQUENCY_UPDATE_ALL_FILES" ) )
					{
						g_iConfig[ FREQUENCY_UPDATE_ALL_FILES ] = _:str_to_float( szValue );
					}
					
					else if( equali( szKey, "BANS_FILE" ) )
					{
						copy( g_iConfig[ BANS_FILE ], charsmax( g_iConfig[ BANS_FILE ] ), szValue );
					}
					
					else if( equali( szKey, "LOGS_FILE" ) )
					{
						copy( g_iConfig[ LOGS_FILE ], charsmax( g_iConfig[ LOGS_FILE ] ), szValue );
					}
					
					else if( equali( szKey, "CONNECT_LOG" ) )
					{
						g_iConfig[ CONNECT_LOG ] = str_to_num( szValue );
					}
					
					else if( equali( szKey, "NAME_CHANGE_LOG" ) )
					{
						g_iConfig[ NAME_CHANGE_LOG ] = str_to_num( szValue );
					}
					
					else if( equali( szKey, "RANKS_IN_CHAT" ) )
					{
						g_iConfig[ RANKS_IN_CHAT ] = str_to_num( szValue );
					}
					
					else if( equali( szKey, "CHAT_LOG" ) )
					{
						g_iConfig[ CHAT_LOG ] = str_to_num( szValue );
					}
					
					else if( equali( szKey, "CHAT_FLAG" ) )
					{
						g_iConfig[ CHAT_FLAG ] = read_flags( szValue );
					}
					
					else if( equali( szKey, "SHOW_ADMIN_EXPIRE_DATE" ) )
					{
						g_iConfig[ SHOW_ADMIN_EXPIRE_DATE ] = str_to_num( szValue );
					}
					
					else if( equali( szKey, "ADMIN_EXPIRE_CMD" ) )
					{
						copy( g_iConfig[ ADMIN_EXPIRE_CMD ], charsmax( g_iConfig[ ADMIN_EXPIRE_CMD ] ), szValue );
					}
					
					else if( equali( szKey, "ENABLE_MODELS" ) )
					{
						g_iConfig[ ENABLE_MODELS ] = bool:str_to_num( szValue );
					}
					
					else if( equali( szKey, "TEAM_SAY" ) )
					{
						g_iConfig[ TEAM_SAY ] = bool:str_to_num( szValue );
					}
					
					else if( equali( szKey, "DEFAULT_MODEL_T" ) )
					{
						copy( g_iConfig[ DEFAULT_MODEL_T ], charsmax( g_iConfig[ DEFAULT_MODEL_T ] ), szValue );
					}
					
					else if( equali( szKey, "DEFAULT_MODEL_CT" ) )
					{
						copy( g_iConfig[ DEFAULT_MODEL_CT ], charsmax( g_iConfig[ DEFAULT_MODEL_CT ] ), szValue );
					}
				}
			}
		}
		fclose( iFile );
	}
}

ModelExists( const szModel[ ] )
{
	new szPath[ 128 ];
	formatex( szPath, charsmax( szPath ), "models/player/%s/%s.mdl", szModel, szModel );
						
	if( ! file_exists( szPath ) )
	{
		return -1;
	}
	return 1;
}

GetImmunityLevel( id )
{
	new eData[ PlayerData ], iImmunityLevel;

	if( TrieGetArray( g_tDatabase, g_szAuthId[ id ], eData, sizeof eData ) || TrieGetArray( g_tDatabase, g_szName[ id ], eData, sizeof eData ) )
	{
		iImmunityLevel = eData[ Player_Immunity ];
	}
	return iImmunityLevel;
}

bool:HasAdminExpired( const szDate[ ] )
{
	return get_systime( ) >= parse_time( szDate, "%m/%d/%Y %H:%M:%S" );
}

bool:IsPlayerPrivileged( id )
{
	new eData[ PlayerData ], bool:bPrivileged;
	
	if( TrieGetArray( g_tDatabase, g_szAuthId[ id ], eData, sizeof eData ) || TrieGetArray( g_tDatabase, g_szName[ id ], eData, sizeof eData ) )
	{
		if( ! eData[ Player_Suspended ] && ( ( eData[ Player_Expired ] && eData[ Player_KeepPrivileges ] ) || ! eData[ Player_Expired ] ) )
		{
			bPrivileged = true;
		}
	}
	return bPrivileged;
}

send_message( const id, const iWhere, bool:bPrefix, const szInput[ ], any:... )
{
	new szMessage[ 192 ];
	vformat( szMessage, charsmax( szMessage ), szInput, 5 );

	CC_RemoveColors( szMessage, charsmax( szMessage ), true );
	
	bPrefix ? format( szMessage, charsmax( szMessage ), "%s %s", g_iConfig[ SYSTEM_PREFIX ], szMessage ) : format( szMessage, charsmax( szMessage ), "%s", szMessage );
	
	switch( iWhere )
	{
	case CHAT:
		{
			client_print( id, print_chat, szMessage )
		}
		
	case CONSOLE:
		{
			client_print( id, print_console, szMessage )
		}
		
	case LOG:
		{
			new szDate[ MAX_DATE_LENGTH ], szNewLogsFile[ 256 ];
			get_time( "%m-%d-%Y", szDate, charsmax( szDate ) );
			
			formatex( szNewLogsFile, charsmax( szNewLogsFile ),	"%s_%s.ini", g_iConfig[ LOGS_FILE ], szDate );
			log_to_file( szNewLogsFile, szMessage );
		}
	}
}

Print_Message( const message[ ], const id, const i )
{
	message_begin( MSG_ONE, g_iSayTxtMsg, { 0, 0, 0 }, i )
	write_byte( id )
	write_string( message )
	message_end( )
}

GetTeamName( iTeam, szOutput[ ], iSize )
{
	switch( iTeam )
	{
	case TEAM_T:
		{
			copy( szOutput, iSize, "Terrorist" );
		}

	case TEAM_CT:
		{
			copy( szOutput, iSize, "Counter-Terrorist" );
		}

	case TEAM_SPEC:
		{
			copy( szOutput, iSize, "Spectator" );
		}
	}
}